Name:       perl-mogilefs-server
Version:    2.36
Release:    1%{?dist}
Summary:    Server part of the MogileFS distributed filesystem
License:    GPL+ or Artistic
Group:      System Environment/Daemons
URL:        http://search.cpan.org/dist/mogilefs-server/
Source0:    http://search.cpan.org/CPAN/authors/id/D/DO/DORMANDO/mogilefs-server-%{version}.tar.gz
Source1:    mogstored.init
Source2:    mogilefsd.init
Source3:    mogilefsd.conf
Source4:    mogilefs.conf
Patch0:     mogilefs-remove_deps.patch

BuildArch:  noarch

BuildRequires:  perl(ExtUtils::MakeMaker)
BuildRequires:  perl(Test::More)
BuildRequires:  perl(MogileFS::Utils)
BuildRequires:  perl(MogileFS::Client)
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

Provides:  mogilefs-server = %{version}-%{release}
Obsoletes: mogilefs-server < 2.17-5


%description
Server part of the MogileFS distributed filesystem


%package -n mogilefsd
Summary:        MogileFS tracker daemon
Group:          System Environment/Daemons
Requires:       initscripts
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Requires(pre):  shadow-utils
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
BuildRequires:  perl(Net::Netmask)
BuildRequires:  perl(DBD::mysql)


%package -n mogstored
Summary:        MogileFS storage daemon
Group:          System Environment/Daemons
Requires:       initscripts
Requires:       sysstat
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Requires(pre):  shadow-utils
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
Requires:       perl(Mogstored::HTTPServer::None)
BuildRequires:  perl(Gearman::Client::Async)
BuildRequires:  perl(Gearman::Server)


%package -n mogstored-backend-perlbal
Summary:    Perlbal backend for mogstored
Group:      System Environment/Daemons
Requires:   perl(Mogstored::HTTPServer), Perlbal
Requires:   perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
BuildRequires: perl(Perlbal)


%package -n mogstored-backend-apache
Summary:    Apache backend for mogstored
Group:      System Environment/Daemons
Requires:   perl(Mogstored::HTTPServer), httpd
Requires:   perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))


%package -n mogstored-backend-lighttpd
Summary:    LigHTTPd backend for mogstored
Group:      System Environment/Daemons
Requires:   perl(Mogstored::HTTPServer), lighttpd
Requires:   perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%package -n mogstored-backend-none
Summary:    Backend which allows mogstored to work with unmanaged DAV servers
Group:      System Environment/Daemons
Requires:   perl(Mogstored::HTTPServer)
Requires:   perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))


%description -n mogilefsd
The MogileFS tracker daemon mogilefsd


%description -n mogstored
The MogileFS storage daemon mogstored


%description -n mogstored-backend-perlbal
Perlbal backend for mogstored, the MogileFS storage daemon


%description -n mogstored-backend-apache
Apache backend for mogstored, the MogileFS storage daemon


%description -n mogstored-backend-lighttpd
LigHTTPd backend for mogstored, the MogileFS storage daemon

%description -n mogstored-backend-none
Backend which allows mogstored to work with unmanaged DAV servers


%prep
%setup -q -n mogilefs-server-%{version}
%patch0 -p1

# Remove mogstored backends and Perlbal from Requires:
cat << \EOF > mogstored-req
#!/bin/sh
%{__perl_requires} $* |\
  sed -e '/perl(Mogstored::HTTPServer::.*)/d' \
  -e '/perl(Perlbal)/d'
EOF

%define __perl_requires %{_builddir}/mogilefs-server-%{version}/mogstored-req
chmod +x %{__perl_requires}


%build
rm -rv lib/mogdeps
%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}


%install
make pure_install PERL_INSTALL_ROOT=%{buildroot}

find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -depth -type d -exec rmdir {} 2>/dev/null \;

%{_fixperms} %{buildroot}/*

%{__install} -d -m0755 %{buildroot}%{_initrddir}
%{__install} -p -m0755 %{SOURCE1} %{buildroot}%{_initrddir}/mogstored
%{__install} -p -m0755 %{SOURCE2} %{buildroot}%{_initrddir}/mogilefsd

%{__install} -d -m0755 %{buildroot}%{_sysconfdir}/mogilefs
%{__install} -p -m0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/mogilefs/mogilefsd.conf
%{__install} -p -m0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/mogilefs/mogilefs.conf

# remove the SQLite backend for now, since the latest driver
# is not in Fedora yet (#245699) and most people are probably
# only interested in the MySQL backend
# the PostgreSQL backend is not stable yet
rm %{buildroot}%{perl_vendorlib}/MogileFS/Store/SQLite.pm
rm %{buildroot}%{perl_vendorlib}/MogileFS/Store/Postgres.pm


%check
rm t/mogstored-shutdown.t
make test


%pre -n mogilefsd
getent group mogilefsd >/dev/null || groupadd -r mogilefsd
getent passwd mogilesd >/dev/null || \
    useradd -r -g mogilefsd -d / -s /sbin/nologin \
    -c "MogileFS tracker daemon" mogilefsd
exit 0

%post -n mogilefsd
if [ $1 -eq 1 ]; then
    /sbin/chkconfig --add mogilefsd
fi


%preun -n mogilefsd
if [ $1 -eq 0 ]; then
    /sbin/service mogilefsd stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del mogilefsd
fi


%pre -n mogstored
getent group mogstored >/dev/null || groupadd -r mogstored
getent passwd mogstored >/dev/null || \
    useradd -r -g mogstored -d / -s /sbin/nologin \
    -c "MogileFS storage daemon" mogstored
exit 0


%post -n mogstored
if [ $1 -eq 1 ]; then
    /sbin/chkconfig --add mogstored
fi


%preun -n mogstored
if [ $1 -eq 0 ]; then
    /sbin/service mogstored stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del mogstored
fi


%files -n mogilefsd
%defattr(-,root,root,-)
%doc CHANGES TODO doc/
%{_bindir}/mogilefsd
%{_bindir}/mogdbsetup
%{_mandir}/man1/mogilefsd.*
%{_mandir}/man3/MogileFS::*.*
%{perl_vendorlib}/MogileFS/*
%dir %{perl_vendorlib}/MogileFS
%dir %{_sysconfdir}/mogilefs
%config(noreplace) %{_sysconfdir}/mogilefs/mogilefs.conf
%config(noreplace) %{_sysconfdir}/mogilefs/mogilefsd.conf
%{_initrddir}/mogilefsd


%files -n mogstored
%defattr(-,root,root,-)
%{_bindir}/mogstored
%{_bindir}/mogautomount
%{_mandir}/man1/mogstored.*
%{_mandir}/man1/mogautomount.*
%dir %{perl_vendorlib}/Mogstored
%{perl_vendorlib}/Mogstored/ChildProcess*
%{perl_vendorlib}/Mogstored/FIDStatter.pm
%{perl_vendorlib}/Mogstored/HTTPServer.pm
%{perl_vendorlib}/Mogstored/SideChannel*
%{_initrddir}/mogstored


%files -n mogstored-backend-perlbal
%defattr(-,root,root,-)
%{perl_vendorlib}/Mogstored/HTTPServer/Perlbal.pm


%files -n mogstored-backend-apache
%defattr(-,root,root,-)
%{perl_vendorlib}/Mogstored/HTTPServer/Apache.pm


%files -n mogstored-backend-lighttpd
%defattr(-,root,root,-)
%{perl_vendorlib}/Mogstored/HTTPServer/Lighttpd.pm

%files -n mogstored-backend-none
%defattr(-,root,root,-)
%{perl_vendorlib}/Mogstored/HTTPServer/None.pm


%changelog
* Thu Jun 24 2010 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.36-1
- Upstream released new version

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 2.30-4
- rebuild against perl 5.10.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.30-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.30-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Jan 19 2009 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.30-1
- Upstream released new version

* Sun Oct 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.20-4
- Add the 'None' backend

* Sun Oct 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.20-3
- Remove the included dependencies before building, not after

* Sun Oct 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.20-2
- Remove included dependencies

* Sun Oct 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.20-1
- Upstream released new version

* Wed Aug 13 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-7
- Add compat statements for subpackages

* Wed Aug 13 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-6
- Due to a problem in the tempfile handling, mogilefs occasionally 
  looses file data after a while. Bz 458890

* Sat Feb 09 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-5
- Rename package to respect the Naming Guidelines

* Sat Jan 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-4
- Require Perlbal instead of perlbal
- Remove autogenerated Perlbal dependency from mogstored

* Sat Jan 19 2008 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-3
- Add Requires for perlbal to perlbal backend
- Rename package
- Remove failing test

* Thu Sep 06 2007 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-2
- Add missing BRs (#252257)
* Sun May 20 2007 Ruben Kerkhof <ruben@rubenkerkhof.com> 2.17-1
- Initial import

